using Microsoft.Extensions.Logging;
using FishFactoryContracts.BindingModels;
using FishFactoryContracts.BusinessLogicsContracts;
using FishFactoryContracts.SearchModels;
using FishFactoryDataModels.Models;

namespace FishFactoryView
{
    public partial class FormCanned : Form
    {
        private readonly ILogger _logger;
        private readonly ICannedLogic _logic;
        private int? _id;
        private Dictionary<int, (IIngredientModel, int)> _cannedIngredients;
        public int Id { set { _id = value; } }
        public FormCanned(ILogger<FormCanned> logger, ICannedLogic logic)
        {
            InitializeComponent();
            _logger = logger;
            _logic = logic;
            _cannedIngredients = new Dictionary<int, (IIngredientModel, int)>();
        }
        private void FormCanned_Load(object sender, EventArgs e)
        {
            if (_id.HasValue)
            {
                _logger.LogInformation("Загрузка консервы");
                try
                {
                    var view = _logic.ReadElement(new CannedSearchModel
                    {
                        Id = _id.Value
                    });
                    if (view != null)
                    {
                        textBoxName.Text = view.CannedName;
                        textBoxPrice.Text = view.Price.ToString();
                        _cannedIngredients = view.CannedIngredients ?? new Dictionary<int, (IIngredientModel, int)>();
                        LoadData();
                    }
                }
                catch (Exception ex)
                {
                    _logger.LogError(ex, "Ошибка загрузки консервы");
                    MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                }
            }
        }
        private void LoadData()
        {
            _logger.LogInformation("Загрузка ингредиента консервы");
            try
            {
                if (_cannedIngredients != null)
                {
                    dataGridView.Rows.Clear();
                    foreach (var sc in _cannedIngredients)
                    {
                        dataGridView.Rows.Add(new object[] { sc.Key, sc.Value.Item1.IngredientName, sc.Value.Item2 });
                    }
                    textBoxPrice.Text = CalcPrice().ToString();
                }
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, "Ошибка загрузки ингредиента консервы");
                MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        private void ButtonAdd_Click(object sender, EventArgs e)
        {
            var service = Program.ServiceProvider?.GetService(typeof(FormCannedIngredients));
            if (service is FormCannedIngredients form)
            {
                if (form.ShowDialog() == DialogResult.OK)
                {
                    if (form.IngredientModel == null)
                    {
                        return;
                    }
                    _logger.LogInformation("Добавление нового ингредиента: { IngredientName} - { Count}", form.IngredientModel.IngredientName, form.Count);
                    if (_cannedIngredients.ContainsKey(form.Id))
                    {
                        _cannedIngredients[form.Id] = (form.IngredientModel,
                       form.Count);
                    }
                    else
                    {
                        _cannedIngredients.Add(form.Id, (form.IngredientModel,
                       form.Count));
                    }
                    LoadData();
                }
            }
        }
        private void ButtonUpd_Click(object sender, EventArgs e)
        {
            if (dataGridView.SelectedRows.Count == 1)
            {
                var service = Program.ServiceProvider?.GetService(typeof(FormCannedIngredients));
                if (service is FormCannedIngredients form)
                {
                    int id =
                   Convert.ToInt32(dataGridView.SelectedRows[0].Cells[0].Value);
                    form.Id = id;
                    form.Count = _cannedIngredients[id].Item2;
                    if (form.ShowDialog() == DialogResult.OK)
                    {
                        if (form.IngredientModel == null)
                        {
                            return;
                        }
                        _logger.LogInformation("Изменение ингредиента: { IngredientName} - { Count} ", form.IngredientModel.IngredientName, form.Count);
                        _cannedIngredients[form.Id] = (form.IngredientModel, form.Count);
                        LoadData();
                    }
                }
            }
        }
        private void ButtonDel_Click(object sender, EventArgs e)
        {
            if (dataGridView.SelectedRows.Count == 1)
            {
                if (MessageBox.Show("Удалить запись?", "Вопрос",
               MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                {
                    try
                    {
                        _logger.LogInformation("Удаление ингредиента: { IngredientName} - { Count} ", 
                            dataGridView.SelectedRows[0].Cells[1].Value); _cannedIngredients?.Remove(Convert.ToInt32(dataGridView.SelectedRows[0].Cells[0].Value));
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show(ex.Message, "Ошибка",
                       MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                    LoadData();
                }
            }
        }
        private void ButtonRef_Click(object sender, EventArgs e)
        {
            LoadData();
        }
        private void ButtonSave_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(textBoxName.Text))
            {
                MessageBox.Show("Заполните название", "Ошибка",
               MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (string.IsNullOrEmpty(textBoxPrice.Text))
            {
                MessageBox.Show("Заполните цену", "Ошибка", MessageBoxButtons.OK,
               MessageBoxIcon.Error);
                return;
            }
            if (_cannedIngredients == null || _cannedIngredients.Count == 0)
            {
                MessageBox.Show("Заполните ингредиенты", "Ошибка",
               MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            _logger.LogInformation("Сохранение консервы");
            try
            {
                var model = new CannedBindingModel
                {
                    Id = _id ?? 0,
                    CannedName = textBoxName.Text,
                    Price = Convert.ToDouble(textBoxPrice.Text),
                    CannedIngredients = _cannedIngredients
                };
                var operationResult = _id.HasValue ? _logic.Update(model) : _logic.Create(model);
                if (!operationResult)
                {
                    throw new Exception("Ошибка при сохранении. Дополнительная информация в логах.");
                }
                MessageBox.Show("Сохранение прошло успешно", "Сообщение", MessageBoxButtons.OK, MessageBoxIcon.Information);
                DialogResult = DialogResult.OK;
                Close();
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, "Ошибка сохранения консервы");
                MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        private void ButtonCancel_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            Close();
        }
        private double CalcPrice()
        {
            double price = 0;
            foreach (var elem in _cannedIngredients)
            {
                price += ((elem.Value.Item1?.Cost ?? 0) * elem.Value.Item2);
            }
            return Math.Round(price * 1.1, 2);
        }
    }
}
